--- /etc/init.d/clamav-milter	2010-09-23 13:42:48.000000000 +0200
+++ /tmp/clamav-milter	2010-10-21 10:21:00.892392574 +0200
@@ -23,35 +23,6 @@
 
 [ -x "$DAEMON" ] || exit 0
 
-status_of_proc () {
-    local pidfile daemon name status
-
-    pidfile=
-    OPTIND=1
-    while getopts p: opt ; do
-        case "$opt" in
-            p)  pidfile="$OPTARG";;
-        esac
-    done
-    shift $(($OPTIND - 1))
-
-    if [ -n "$pidfile" ]; then
-        pidfile="-p $pidfile"
-    fi
-    daemon="$1"
-    name="$2"
-
-    status="0"
-    pidofproc $pidfile $daemon >/dev/null || status="$?"
-    if [ "$status" = 0 ]; then
-        log_success_msg "$name is running"
-        return 0
-    else
-        log_failure_msg "$name is not running"
-        return $status
-    fi
-}
-
 to_lower()
 {
   word="$1"
@@ -276,6 +247,38 @@
   SOCKET="$MilterSocket"
 fi
 
+status_of_proc () {
+    local pidfile daemon name status
+
+    pidfile=
+    OPTIND=1
+    while getopts p: opt ; do
+        case "$opt" in
+            p)  pidfile="$OPTARG";;
+        esac
+    done
+    shift $(($OPTIND - 1))
+
+    if [ -n "$pidfile" ]; then
+        pidfile="-p $pidfile"
+    fi
+    daemon="$1"
+    name="$2"
+
+    status="0"
+    pidofproc $pidfile $daemon >/dev/null || status="$?"
+    if ( [ "$status" = 0 ] && [ -S $SOCKET_PATH ] ); then
+        log_success_msg "$name is running"
+        return 0
+    elif ( [ "$status" = 0 ] && [ ! -S $SOCKET_PATH ] ); then
+        log_failure_msg "$name socket missing"
+        return 4
+    else
+        log_failure_msg "$name is not running"
+        return $status
+    fi
+}
+
 wait_for_socket()
 {
   local socket; socket="$1"
@@ -431,7 +434,7 @@
   $0 start
   ;;
   status)
-  status_of_proc "$DAEMON" "$NAME"
+  status_of_proc "$DAEMON" "$BASENAME"
   exit $?
   ;;
   *)
